/*************************************************************************************
 * Copyright (C) 2014-2016 GENERAL BYTES s.r.o. All rights reserved.
 *
 * This software may be distributed and modified under the terms of the GNU
 * General Public License version 2 (GPL2) as published by the Free Software
 * Foundation and appearing in the file GPL2.TXT included in the packaging of
 * this file. Please note that GPL2 Section 2[b] requires that all works based
 * on this software must also be made publicly available under the terms of
 * the GPL2 ("Copyleft").
 *
 * Contact information
 * -------------------
 *
 * GENERAL BYTES s.r.o.
 * Web      :  http://www.generalbytes.com
 *
 ************************************************************************************/
package com.generalbytes.batm.server.extensions;


public interface ITask {
    /**
     * Called when task is created
     * @return
     */
    public boolean onCreate();
    /**
     * Called periodically to perform repeating jobs
     * @return
     */
    public boolean onDoStep();
    /**
     * Called when task is finished
     * @return
     */
    public void onFinish();

    /**
     * This method is called by task manager to test if it should be removed from list of tasks
     * @return
     */
    public boolean isFinished();

    /**
     * Called to obtain result of task
     * @return
     */
    public Object getResult();

    /**
     * Called to check if task has failed
     * @return
     */
    public boolean isFailed();

    /**
     * Called by task manager to correctly schedule next call of onDoStep
     * @return
     */
    public long getShortestTimeForNexStepInvocation();
}
